#include <stdlib.h>
#include <stdio.h>
#include <dos.h>
#include <iostream.h>

typedef unsigned char byte;
typedef unsigned int word;
typedef unsigned char pal[256][3];

void makefont(word &adr,byte *&FONT);    // skapar en fontbank
void killfont(byte *kill);               // raderar en --||--
void loadfont(char *fnamn,byte *FONT,pal &palett); // laddar in en FNT-fil
void text(int let,int x,int y,int col,word FONT,word DEST); // textar EN bokstav
void write(char* txt,int x,int y,int col,word FONT,word DEST); // textar FLERA
void write_O(char* txt,int x,int y,int col,int ocol,word FONT,word DEST); // textar FLERA med Outline
void type(long number,int x,int y,int col,word FONT,word DEST); // textar ett tal

void makefont(word &adr,byte *&FONT)
// skapar en iconbank som kan kommas t med hjlp av
// 'adr' eller FONT
{
  FONT = (byte *) malloc(6154);

  // kolla alltid om det finns tillrckligt med minne!
  if (FONT == NULL)
  {
    cout << "Not enough memory. 6154 b wanted.";
    free(FONT);
    exit(1);
  }

  adr = FP_SEG(FONT);
}

void killfont(byte *kill)
// frigr minnet som skrmen 'adr' upptog
{
  free(kill);
}

void write(char* txt,int x,int y,int col,word FONT,word DEST)
// skriver ut txt till DEST
{
  int i=0;
  while (txt[i]!='\0')
  {
    text(txt[i],x+i*8,y,col,FONT,DEST);
    i++;
  }
}

void type(long number,int x,int y,int col,word FONT,word DEST)
// skriver ut nummer till DEST (alltid hgerjusterade)
{
  long n,t;

  if (number==0) text('0',x+72,y,col,FONT,DEST);
  else
  {
    for(int i=0;i<10;i++)
    {
      n=number/10;
      n=n*10;
      t=number-n;
      if (t==0 && number>0) text('0',x+(9-i)*8,y,col,FONT,DEST);
      if (t==1) text('1',x+(9-i)*8,y,col,FONT,DEST);
      if (t==2) text('2',x+(9-i)*8,y,col,FONT,DEST);
      if (t==3) text('3',x+(9-i)*8,y,col,FONT,DEST);
      if (t==4) text('4',x+(9-i)*8,y,col,FONT,DEST);
      if (t==5) text('5',x+(9-i)*8,y,col,FONT,DEST);
      if (t==6) text('6',x+(9-i)*8,y,col,FONT,DEST);
      if (t==7) text('7',x+(9-i)*8,y,col,FONT,DEST);
      if (t==8) text('8',x+(9-i)*8,y,col,FONT,DEST);
      if (t==9) text('9',x+(9-i)*8,y,col,FONT,DEST);
      number=n/10;
    }
  }
}

void write_O(char* txt,int x,int y,int col,int ocol,word FONT,word DEST)
// skriver ut txt till DEST
{
  write(txt,x-1,y,ocol,FONT,DEST);
  write(txt,x+1,y,ocol,FONT,DEST);
  write(txt,x,y-1,ocol,FONT,DEST);
  write(txt,x,y+1,ocol,FONT,DEST);
  write(txt,x,y,col,FONT,DEST);
}

void text(int let,int x,int y,int col,word FONT,word DEST)
// skriver ut en bosktav utan bakgrundsfrg
// frn banken FONT till skrmen DEST
{
  if (let!=32)
  {
  int fpos,pos;

  fpos=(let-32)*64;
  pos=x+y*320;
  asm{
    PUSH  ds
    MOV   ax,[FONT]
    MOV   ds,ax
    MOV   si,fpos
    MOV   ax,[DEST]
    MOV   es,ax
    MOV   di,pos
    CLD
    XOR   bx,bx
    XOR   cx,cx
    JMP   _Rita
    }
   _Masking: asm{
    INC   si
    INC   di
    JMP   _Next
    }
   _NyFarg: asm{
    MOV   ax,col
    STOSB
    INC   si
    JMP  _Next
    }
   _Rita: asm{
    MOV   dl,ds:[si]
    CMP   dl,0
    JZ    _Masking
    CMP   col,0
    JNZ   _NyFarg
    MOVSB
    }
   _Next: asm{
    INC   cx
    CMP   cx,8
    JNZ   _Rita
    INC   bx
    ADD   di,312
    XOR   cx,cx
    CMP   bx,8
    JL    _Rita
    POP   ds
  }
  }
}

void loadfont(char *fnamn,byte *FONT,pal &palett)
// laddar in en FNT-fil i FONT med paletten i pal
{
  FILE *fp;

  fp=fopen(fnamn,"rb");
  fread(FONT,6144,1,fp);
  fread(palett,sizeof(pal),1,fp);
  fclose(fp);
}
